
void Datenanalyse() {

//Zellspannungen
  uint8_t j,i;
  
  //Zellspannungen
  for(j=0,i=7; i<38; j++,i+=2) {
    cellVoltage[j] = (((int)receivedBytes_main[i] << 8 | receivedBytes_main[i-1])*0.001);
  }

// +20 byte Zelle 15 - 24
// +4 Byte unbekannt
Average_Cell_Voltage = (((int)receivedBytes_main[59] << 8 | receivedBytes_main[58])*0.001); 
Delta_Cell_Voltage = (((int)receivedBytes_main[61] << 8 | receivedBytes_main[60])*0.001); 
Current_Balancer = (((int)receivedBytes_main[63] << 8 | receivedBytes_main[62])*0.001); 
// +48 byte Resistance_Cell1
// +6 byte unbekant 2
Battery_Voltage = (((int)receivedBytes_main[121] << 24 | receivedBytes_main[120] << 16 | receivedBytes_main[119] << 8 | receivedBytes_main[118])*0.001);

Battery_Power = (((int)receivedBytes_main[125] << 24 | (int)receivedBytes_main[124] << 16 | (int)receivedBytes_main[123] << 8 | (int)receivedBytes_main[122])*0.001);
Charge_Current = (((int)receivedBytes_main[129] << 24 | receivedBytes_main[128] << 16 | receivedBytes_main[127] << 8 | receivedBytes_main[126])*0.001);
//CAN_Charge_Current = ((int)receivedBytes_main[129] << 24 | receivedBytes_main[128] << 16 | receivedBytes_main[127] << 8 | receivedBytes_main[126] / 100);
 
//Battery_Power = (((int)receivedBytes_main[121] << 8 | receivedBytes_main[120])*0.001); unbekannt ?!
//Battery_Power = (((int)receivedBytes_main[123] << 8 | receivedBytes_main[122])*0.001); 
// +6 byte unbekant 3


//Battery_T1 = (((int)receivedBytes_main[131] << 8 | receivedBytes_main[130])*0.1);
//CAN_Battery_T1 = ((int)receivedBytes_main[131] << 8 | receivedBytes_main[130]);
if(receivedBytes_main[131] == 0xFF) {
  Battery_T1 = ((0xFF << 24 | 0xFF << 16 | (int)receivedBytes_main[131] << 8 | (int)receivedBytes_main[130])*0.1);   
}
else {
Battery_T1 = (((int)receivedBytes_main[131] << 8 | (int)receivedBytes_main[130])*0.1);  
}


//Battery_T2 = (((int)receivedBytes_main[133] << 8 | (int)receivedBytes_main[132])*0.1); 
if(receivedBytes_main[133] == 0xFF) {
  Battery_T2 = ((0xFF << 24 | 0xFF << 16 | (int)receivedBytes_main[133] << 8 | (int)receivedBytes_main[132])*0.1);   
}
else {
Battery_T2 = (((int)receivedBytes_main[133] << 8 | (int)receivedBytes_main[132])*0.1);   
}


//MOS_Temp = (((int)receivedBytes_main[135] << 8 | receivedBytes_main[134])*0.1); 
if(receivedBytes_main[135] == 0xFF) {
  MOS_Temp = ((0xFF << 24 | 0xFF << 16 | (int)receivedBytes_main[135] << 8 | (int)receivedBytes_main[134])*0.1);   
}
else {
MOS_Temp = (((int)receivedBytes_main[135] << 8 | (int)receivedBytes_main[134])*0.1);   
}

if((receivedBytes_main[139] & 0xF0) == 0x0) {
  Balance_Curr = (((int)receivedBytes_main[139] << 8 | receivedBytes_main[138])*0.001); 
}
else if ((receivedBytes_main[139] & 0xF0) == 0xF0) {
  Balance_Curr = ((((int)receivedBytes_main[139] & 0x0F) << 8 | receivedBytes_main[138])*-0.001); 
}
// +2 byte unbekant 4
Percent_Remain = ((int)receivedBytes_main[141]); 
Capacity_Remain = (((int)receivedBytes_main[145] << 24 | receivedBytes_main[144] << 16 | receivedBytes_main[143] << 8 | receivedBytes_main[142])*0.001); 
Nominal_Capacity = (((int)receivedBytes_main[149] << 24 | receivedBytes_main[148] << 16 | receivedBytes_main[147] << 8 | receivedBytes_main[146])*0.001); 
Cycle_Count = receivedBytes_main[153] + receivedBytes_main[152] + receivedBytes_main[151] + receivedBytes_main[150];                        //((String)receivedBytes_main[153] << 24 | receivedBytes_main[152] << 16 | receivedBytes_main[151] << 8 | receivedBytes_main[150])); 
// +6 byte unbekant 5
Capacity_Cycle = (((int)receivedBytes_main[161] << 8 | receivedBytes_main[160])*0.001); 
Uptime = (((int)receivedBytes_main[164] << 16 | receivedBytes_main[163] << 8 | receivedBytes_main[162])); 
sec = Uptime % 60;
  Uptime /= 60;
  mi = Uptime % 60;
  Uptime /= 60;
  hr = Uptime % 24;
  days = Uptime /= 24;

// +1 byte unbekannt
if(receivedBytes_main[166] > 0) {
  charge = "on";
}
else if (receivedBytes_main[166] == 0) {
  charge = "off";  
}
if(receivedBytes_main[167] > 0) {
  discharge = "on";
}
else if (receivedBytes_main[167] == 0) {
  discharge = "off";  
}

if (Charge_Current < 0) {
  Battery_Power * -1;
}
new_data = false;

// Full Log ausgaben...
if(debug_flg_full_log) {

    Serial.print("Cell Voltages = ");
    for(i=0; i<16; i++) {
      Serial.print(cellVoltage[i], 3); 
      i<15 ? Serial.print("V, ") : Serial.println("V");
    }

//unbekant1 4 byte
Serial.print("unbekant 1 = ");
Serial.print(receivedBytes_main[57],HEX);
Serial.print(", ");
Serial.print(receivedBytes_main[56],HEX);
Serial.print(", ");
Serial.print(receivedBytes_main[55],HEX);
Serial.print(", ");
Serial.print(receivedBytes_main[54],HEX);
Serial.print(", ");
Serial.println("");

Serial.print("Average Cell Voltage = ");
Serial.print(Average_Cell_Voltage, 3);
Serial.println("V, ");

Serial.print("Delta Cell Voltage = ");
Serial.print(Delta_Cell_Voltage, 3);
Serial.println("V, ");

Serial.print("Current Balancer = ");
Serial.print(Current_Balancer, 3);
Serial.println("V, ");

//unbekant 2 6 byte
Serial.print("unbekant 2 = ");
Serial.print(receivedBytes_main[117],HEX);
Serial.print(", ");
Serial.print(receivedBytes_main[116],HEX);
Serial.print(", ");
Serial.print(receivedBytes_main[115],HEX);
Serial.print(", ");
Serial.print(receivedBytes_main[114],HEX);
Serial.print(", ");
Serial.print(receivedBytes_main[113],HEX);
Serial.print(", ");
Serial.print(receivedBytes_main[112],HEX);
Serial.print(", ");
Serial.println("");

Serial.print("Battery Voltage = ");
Serial.print(Battery_Voltage, 3);
Serial.println("V, ");

Serial.print("Battery Power = ");
Serial.print(Battery_Power, 3);
Serial.println("W, ");

Serial.print("Charge Current = ");
Serial.print(Charge_Current, 3);
Serial.println("A, ");

//unbekant 3 6 byte
Serial.print("Analyse = ");
Serial.print(receivedBytes_main[116],HEX);
Serial.print(", ");
Serial.print(receivedBytes_main[117],HEX);
Serial.print(", ");
Serial.print(receivedBytes_main[118],HEX);
Serial.print(", ");
Serial.print(receivedBytes_main[119],HEX);
Serial.print(", ");
Serial.print(receivedBytes_main[120],HEX);
Serial.print(", ");
Serial.print(receivedBytes_main[121],HEX);
Serial.print(", ");
Serial.print(receivedBytes_main[122],HEX);
Serial.print(", ");
Serial.print(receivedBytes_main[123],HEX);
Serial.println("");

//unbekant 3 6 byte
Serial.print("unbekant 3 = ");
Serial.print(receivedBytes_main[124],HEX);
Serial.print(", ");
Serial.print(receivedBytes_main[125],HEX);
Serial.print(", ");
Serial.print(receivedBytes_main[126],HEX);
Serial.print(", ");
Serial.print(receivedBytes_main[127],HEX);
Serial.print(", ");
Serial.print(receivedBytes_main[128],HEX);
Serial.print(", ");
Serial.print(receivedBytes_main[129],HEX);
Serial.print(", ");
Serial.println("");

Serial.print("Battery T1 = ");
Serial.print(Battery_T1, 3);
Serial.println("°C, ");

Serial.print("Battery T2 = ");
Serial.print(Battery_T2, 3);
Serial.println("°C, ");

Serial.print("MOS Temp = ");
Serial.print(MOS_Temp, 3);
Serial.println("°C, ");

Serial.print("Balance_Curr = ");
Serial.print(Balance_Curr, 3);
Serial.println("A, ");


//unbekant 4 2 byte
Serial.print("unbekant 4 = ");
Serial.print(receivedBytes_main[137],HEX);
Serial.print(", ");
Serial.print(receivedBytes_main[136],HEX);
Serial.print(", ");
Serial.println("");


Serial.print("Percent Remain = ");
Serial.print(Percent_Remain);
Serial.println("%, ");

Serial.print("Capacity Remain = ");
Serial.print(Capacity_Remain, 3);
Serial.println(", ");

Serial.print("Nominal Capacity = ");
Serial.print(Nominal_Capacity, 3);
Serial.println(", ");

Serial.print("Cycle Count = ");
Serial.print(Cycle_Count);
Serial.println(", ");

//unbekant 5 3 byte
Serial.print("unbekant 5 = ");
Serial.print(receivedBytes_main[159],HEX);
Serial.print(", ");
Serial.print(receivedBytes_main[158],HEX);
Serial.print(", ");
Serial.print(receivedBytes_main[157],HEX);
Serial.print(", ");
Serial.print(receivedBytes_main[156],HEX);
Serial.print(", ");
Serial.print(receivedBytes_main[155],HEX);
Serial.print(", ");
Serial.print(receivedBytes_main[154],HEX);
Serial.print(", ");
Serial.println("");

Serial.print("Capacity Cycle = ");
Serial.print(Capacity_Cycle, 3);
Serial.println(", ");

Serial.print("Tage: "); Serial.print(days);
Serial.print(" Stunden: "); Serial.print(hr);
Serial.print(" Minuten: "); Serial.print(mi);
Serial.print(" Sekunden: "); Serial.println(sec);


//unbekant 6 1 byte
Serial.print("unbekant 5 = ");
Serial.print(receivedBytes_main[165],HEX);
Serial.print(", ");
Serial.println("");

Serial.print("Charge on? = ");
Serial.print(charge);
Serial.println(", ");

Serial.print("Discharge on? = ");
Serial.print(discharge);
Serial.println(", ");

//unbekant 6 .... byte
Serial.print("unbekant 7 = ");
 for (int i = 168; i < 230; i++)  {
   Serial.print(receivedBytes_main[i],HEX);
   Serial.print(", ");
 }
 Serial.println("");

}

}
